package org.sample.transactions;

import javax.transaction.TransactionManager;

import org.drools.KnowledgeBase;
import org.drools.builder.ResourceType;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.sample.utils.Utils;

public class RuleFlowGroup {
    public static void main(String[] args) throws Exception {
        KnowledgeBase kbase = Utils.createKnowledgeBuilder(
                Utils.createResource("rfg.bpmn", RuleFlowGroup.class, ResourceType.BPMN2),
                Utils.createResource("rfg.drl", RuleFlowGroup.class, ResourceType.DRL)).newKnowledgeBase();

        StatefulKnowledgeSession ksession = Utils.createPersistedSession(kbase);

        TransactionManager txm = com.arjuna.ats.jta.TransactionManager.transactionManager();
        txm.begin();

        long processId = ksession.startProcess("rfg").getId();

        txm.rollback();
        ksession.fireAllRules();

        ProcessInstance pi = ksession.getProcessInstance(processId);
        System.out.println(pi != null ? Utils.convertState(pi.getState()) : "no instance");

        ksession.dispose();
    }
}
